/*************************************************************************************
 3D Visualization - Learning Magic     
 Tested in Processing 4                                    
 
 Author: Zijian Wan                       
 Supervisor: George Legrady                           
 
 Purpose: This project visualizes the journey books about learning magic have been kept 
 by the readers.  
 
 *************************************************************************************/


import peasy.*;
import controlP5.*;


PeasyCam cam;
ControlP5 cp5;

PFont f;

Table table;
int n_rows;
int d=150;  // diameter
int year_dZ = 200;
boolean showRecords;
int[] annualCouts = new int[10];  // array of annual checkouts (by default, the values are initialized to 0)
float[] d_arr = new float[10];  // array of diameters for each year
ArrayList<Record> records = new ArrayList<Record>();

// int yearMove = 0;
String[] month = {"JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"};

void setup() {
  size(3000, 2000, P3D);
  // fullScreen(P3D);
  //f = createFont("LetterGothicStd.otf", 60);
  
  cam = new PeasyCam(this, 225);
  cam.setMaximumDistance(3000);
  cam.lookAt(0, 0, -800);
  
  cp5 = new ControlP5(this);
  cp5.addToggle("showRecords")
    .setPosition(300, 1000)
    .setSize(100,30)
    ;
  cp5.setAutoDraw(false);
  
  loadData();
  //println(records.get(1).rent_hours); //test whether the data has been successfully loaded 
  annualCouts = annualCoutCounts(records);
  d_arr = determineDiameters(annualCouts);
}

void draw() {
  background(0);
  
  // showRecords = true;
  
  // time circles
  // translate (0,0,yearMove);
  pushMatrix();
  for (int year=2012; year<2022; year++) {
    noFill();
    drawTimeCircle(year, d_arr);
    strokeWeight(2);
    //textFont(f, 5);
     textSize(25);
    fill(209);
    text (year, 400, 10, 10);
    
    // Move onto the next ellipse
    translate (0, 0, -year_dZ);
  }
  popMatrix();
  
  if (showRecords == true) {
    drawRecords(records, d_arr);
  }
  gui();
}

void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}
